package com.infoly.eclipse.xtext.algo.ui.perspectives

import org.eclipse.ui.IPageLayout
import org.eclipse.ui.IPerspectiveFactory
import org.eclipse.ui.console.IConsoleConstants

class AlgorithmicPerspectiveFactory implements IPerspectiveFactory {
 
 	override void createInitialLayout(IPageLayout layout) { 
		// Editors are placed for free.
		var editorArea = layout.getEditorArea()
		// Place navigator to left of editor area.
		var left = layout.createFolder("left", IPageLayout::LEFT, (0.25 as float), editorArea)
//		left.addView(IPageLayout::ID_RES_NAV) OBSOLETE
		left.addView(IPageLayout::ID_PROJECT_EXPLORER)
		// Place outline to right of editor area.
		var right = layout.createFolder("right", IPageLayout::RIGHT, (0.75 as float), editorArea)
		right.addView(IPageLayout::ID_OUTLINE)
		// Place view problem and view console to bottom of editor area.
		var bottom = layout.createFolder("bottom", IPageLayout::BOTTOM, (0.75 as float), editorArea)
		bottom.addView(IPageLayout::ID_PROBLEM_VIEW)
		bottom.addView(IConsoleConstants.ID_CONSOLE_VIEW)
	}
	
}