package com.infoly.eclipse.xtext.algo.ui.wizards

import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard
import org.eclipse.ui.dialogs.WizardNewProjectCreationPage
import org.eclipse.xtext.ui.XtextProjectHelper
import org.eclipse.ui.PlatformUI

class NewProject extends BasicNewProjectResourceWizard {
	private val WINDOW_TITLE 				= "Algorithmic New Project"
	private val PAGE_TITLE 					= "Nouveau Projet"
	private val PAGE_DESCRIPTION 			= "Entrez les informations sur le projet."
	private val DEFAULT_PROJECT_NAME		= "ProjetAlgorithmic"
	private val DEFAULT_FILE_EXT  	  		= "alg"
	private val ALGORITHMIC_EDITOR_ID 		= "com.infoly.eclipse.xtext.algo.Algorithmic"  //Voir plugin.xml du projet ui
	private val ALGORITHMIC_PERSPECTIVE_ID 	= "com.infoly.eclipse.xtext.algo.ui.perspectives.algorithmic" 
/* 			
	new() { // TODO Auto-generated constructor stub
	}
*/
	override addPages() {
		super.addPages()
		windowTitle = WINDOW_TITLE									// Dfinit e titre de la fentre						
		val page0 = pages.get(0) as WizardNewProjectCreationPage 	// Rcupre 1re page de classe de base
		page0.title = PAGE_TITLE									// Dfinit le titre de la page
		page0.description = PAGE_DESCRIPTION						// Dfinit la description de la page
		page0.initialProjectName = DEFAULT_PROJECT_NAME				// Nom du projet  crer par dfaut
//		pages.set(0, page0)
	}
 	
	override performFinish() {
		super.performFinish()		// Cration du nouveau projet BasicNewProjectResourceWizard
		// Ajout de la nature Xtext  ce projet
		newProject.description.natureIds = newProject.description.natureIds + #[XtextProjectHelper.NATURE_ID]
		// Dfinition de l'diteur par dfaut 
      	PlatformUI.workbench.editorRegistry.setDefaultEditor( DEFAULT_FILE_EXT, ALGORITHMIC_EDITOR_ID)		
		// Dfinition de la perspective associe au projet
		val window = workbench.activeWorkbenchWindow
		workbench.showPerspective(ALGORITHMIC_PERSPECTIVE_ID, window)      		
    	
		return true
	}
	

}
