package com.infoly.eclipse.xtext.algo.ui.highlighting;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.xtext.ui.editor.syntaxcoloring.DefaultHighlightingConfiguration;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfigurationAcceptor;
import org.eclipse.xtext.ui.editor.utils.TextStyle;

@SuppressWarnings("all")
public class AlgorithmicHighlightingConfiguration extends DefaultHighlightingConfiguration {
  public final static String TYPE_PRIMITIF_ID = "typePrimitif";
  
  public final static String TYPE_STRUCTURED_ID = "typeStructured";
  
  public final static String TYPE_USER_ID = "typeUser";
  
  public final static String CONST_GLOB_ID = "constGlob";
  
  public final static String VAR_GLOB_ID = "varGlob";
  
  public final static String CONST_LOC_ID = "constLoc";
  
  public final static String VAR_LOC_ID = "varLoc";
  
  public final static String FIELD_CONST_GLOB_ID = "fieldConstGlob";
  
  public final static String FIELD_CONST_LOC_ID = "fieldConstLoc";
  
  public final static String FIELD_VAR_GLOB_ID = "fieldVarGlob";
  
  public final static String FIELD_VAR_LOC_ID = "fieldVarLoc";
  
  public final static String MODULE_NAME_ID = "moduleName";
  
  public final static String MODULE_TYPE_ID = "moduleType";
  
  public final static String LIBRARY_NAME_ID = "libraryName";
  
  public final static String ALGO_ERROR_ID = "algoError";
  
  public final static String TEST_ID = "test";
  
  public final static String TEST2_ID = "test2";
  
  public final static String TEST3_ID = "test3";
  
  public final static RGB RGB_COLOR_DARK_CYAN = new RGB(0, 127, 127);
  
  public final static RGB RGB_COLOR_DARK_GREY = new RGB(64, 64, 64);
  
  public final static RGB RGB_COLOR_GREY = new RGB(128, 128, 128);
  
  public final static RGB RGB_COLOR_RED = new RGB(255, 0, 0);
  
  public final static RGB RGB_COLOR_YELLOW = new RGB(255, 255, 0);
  
  public final static RGB RGB_COLOR_GREEN = new RGB(0, 255, 0);
  
  public final static RGB RGB_COLOR_DARK_KAKI = new RGB(122, 102, 0);
  
  public final static RGB RGB_COLOR_KAKI = new RGB(153, 169, 0);
  
  @Override
  public void configure(final IHighlightingConfigurationAcceptor acceptor) {
    super.configure(acceptor);
    TextStyle _typePrimitifTextStyle = this.typePrimitifTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.TYPE_PRIMITIF_ID, "Type Primitif", _typePrimitifTextStyle);
    TextStyle _typeStructuredTextStyle = this.typeStructuredTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.TYPE_STRUCTURED_ID, "Type Structured", _typeStructuredTextStyle);
    TextStyle _typeUserTextStyle = this.typeUserTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.TYPE_USER_ID, "Type User", _typeUserTextStyle);
    TextStyle _constGlobTextStyle = this.constGlobTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.CONST_GLOB_ID, "Constante Glob.", _constGlobTextStyle);
    TextStyle _varGlobTextStyle = this.varGlobTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.VAR_GLOB_ID, "Variable Glob.", _varGlobTextStyle);
    TextStyle _constLocTextStyle = this.constLocTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.CONST_LOC_ID, "Constante Loc.", _constLocTextStyle);
    TextStyle _varLocTextStyle = this.varLocTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.VAR_LOC_ID, "Variable Loc.", _varLocTextStyle);
    TextStyle _fieldConstGlobTextStyle = this.fieldConstGlobTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.FIELD_CONST_GLOB_ID, "Field Const.", _fieldConstGlobTextStyle);
    TextStyle _fieldConstLocTextStyle = this.fieldConstLocTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.FIELD_CONST_LOC_ID, "Field Const.", _fieldConstLocTextStyle);
    TextStyle _fieldVarGlobTextStyle = this.fieldVarGlobTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.FIELD_VAR_GLOB_ID, "Field Var.", _fieldVarGlobTextStyle);
    TextStyle _fieldVarLocTextStyle = this.fieldVarLocTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.FIELD_VAR_LOC_ID, "Field Var.", _fieldVarLocTextStyle);
    TextStyle _libraryTextStyle = this.libraryTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.LIBRARY_NAME_ID, "Library Name", _libraryTextStyle);
    TextStyle _moduleTypeTextStyle = this.moduleTypeTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.MODULE_TYPE_ID, "Module Type", _moduleTypeTextStyle);
    TextStyle _moduleNameTextStyle = this.moduleNameTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.MODULE_NAME_ID, "Module Name", _moduleNameTextStyle);
    TextStyle _algoErrorTextStyle = this.algoErrorTextStyle();
    acceptor.acceptDefaultHighlighting(AlgorithmicHighlightingConfiguration.ALGO_ERROR_ID, "Algo Error", _algoErrorTextStyle);
  }
  
  public TextStyle typePrimitifTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    return textStyle;
  }
  
  public TextStyle typeStructuredTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    return textStyle;
  }
  
  public TextStyle typeUserTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    return textStyle;
  }
  
  public TextStyle constGlobTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_DARK_GREY);
    return textStyle;
  }
  
  public TextStyle varGlobTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_GREY);
    return textStyle;
  }
  
  public TextStyle constLocTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_DARK_GREY);
    return textStyle;
  }
  
  public TextStyle varLocTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_GREY);
    return textStyle;
  }
  
  public TextStyle moduleTypeTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    return textStyle;
  }
  
  public TextStyle libraryTextStyle() {
    TextStyle _keywordTextStyle = this.keywordTextStyle();
    TextStyle textStyle = _keywordTextStyle.copy();
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_DARK_CYAN);
    return textStyle;
  }
  
  public TextStyle moduleNameTextStyle() {
    TextStyle _libraryTextStyle = this.libraryTextStyle();
    TextStyle textStyle = _libraryTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    return textStyle;
  }
  
  public TextStyle fieldConstLocTextStyle() {
    TextStyle _constLocTextStyle = this.constLocTextStyle();
    TextStyle textStyle = _constLocTextStyle.copy();
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_DARK_KAKI);
    return textStyle;
  }
  
  public TextStyle fieldConstGlobTextStyle() {
    TextStyle _fieldConstLocTextStyle = this.fieldConstLocTextStyle();
    TextStyle textStyle = _fieldConstLocTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    return textStyle;
  }
  
  public TextStyle fieldVarLocTextStyle() {
    TextStyle _varLocTextStyle = this.varLocTextStyle();
    TextStyle textStyle = _varLocTextStyle.copy();
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_KAKI);
    return textStyle;
  }
  
  public TextStyle fieldVarGlobTextStyle() {
    TextStyle _fieldVarLocTextStyle = this.fieldVarLocTextStyle();
    TextStyle textStyle = _fieldVarLocTextStyle.copy();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.ITALIC);
    textStyle.setStyle(_plus);
    return textStyle;
  }
  
  public TextStyle algoErrorTextStyle() {
    TextStyle textStyle = new TextStyle();
    int _style = textStyle.getStyle();
    int _plus = (_style + SWT.BOLD);
    textStyle.setStyle(_plus);
    textStyle.setBackgroundColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_RED);
    textStyle.setColor(AlgorithmicHighlightingConfiguration.RGB_COLOR_YELLOW);
    return textStyle;
  }
}
