package com.infoly.eclipse.xtext.algo.ui.highlighting;

import com.infoly.eclipse.xtext.algo.algorithmic.Algorithmic;
import com.infoly.eclipse.xtext.algo.algorithmic.ConstName;
import com.infoly.eclipse.xtext.algo.algorithmic.DataName;
import com.infoly.eclipse.xtext.algo.algorithmic.DataRef;
import com.infoly.eclipse.xtext.algo.algorithmic.LibraryModule;
import com.infoly.eclipse.xtext.algo.algorithmic.LibraryName;
import com.infoly.eclipse.xtext.algo.algorithmic.MODULES_FUNCTION;
import com.infoly.eclipse.xtext.algo.algorithmic.MODULES_PROCEDURE;
import com.infoly.eclipse.xtext.algo.algorithmic.ModuleFunction;
import com.infoly.eclipse.xtext.algo.algorithmic.ModuleName;
import com.infoly.eclipse.xtext.algo.algorithmic.ModuleProcedure;
import com.infoly.eclipse.xtext.algo.algorithmic.ModuleRef;
import com.infoly.eclipse.xtext.algo.algorithmic.TypeName;
import com.infoly.eclipse.xtext.algo.algorithmic.TypeUser;
import com.infoly.eclipse.xtext.algo.algorithmic.VarName;
import com.infoly.eclipse.xtext.algo.algorithmic.VarRef;
import com.infoly.eclipse.xtext.algo.ui.highlighting.AlgorithmicHighlightingConfiguration;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.ide.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.ide.editor.syntaxcoloring.ISemanticHighlightingCalculator;
import org.eclipse.xtext.nodemodel.ICompositeNode;
import org.eclipse.xtext.nodemodel.util.NodeModelUtils;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.util.CancelIndicator;

/**
 * RESTE A VOIR LA COLORATION POUR LES CHAMPS ET LES PARAMETRES
 */
@SuppressWarnings("all")
public class AlgorithmicSemanticHighlightingCalculator implements ISemanticHighlightingCalculator {
  @Override
  public void provideHighlightingFor(final XtextResource arg0, final IHighlightedPositionAcceptor arg1, final CancelIndicator arg2) {
    EList<EObject> _contents = arg0.getContents();
    EObject root = _contents.get(0);
    TreeIterator<EObject> eAllContents = root.eAllContents();
    IHighlightedPositionAcceptor acceptor = arg1;
    EObject object = ((EObject) null);
    ICompositeNode node = ((ICompositeNode) null);
    boolean global = true;
    while (eAllContents.hasNext()) {
      {
        EObject _next = eAllContents.next();
        object = _next;
        ICompositeNode _findActualNodeFor = NodeModelUtils.findActualNodeFor(object);
        node = _findActualNodeFor;
        int offset = node.getOffset();
        int length = node.getLength();
        boolean _matched = false;
        if (object instanceof TypeName) {
          _matched=true;
        }
        if (!_matched) {
          if (object instanceof TypeUser) {
            _matched=true;
          }
        }
        if (_matched) {
          acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.TYPE_USER_ID);
        }
        if (!_matched) {
          if (object instanceof ConstName) {
            _matched=true;
            if (global) {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.CONST_GLOB_ID);
            } else {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.CONST_LOC_ID);
            }
          }
        }
        if (!_matched) {
          if (object instanceof VarName) {
            _matched=true;
            if (global) {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_GLOB_ID);
            } else {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_LOC_ID);
            }
          }
        }
        if (!_matched) {
          if (object instanceof ModuleFunction) {
            _matched=true;
            MODULES_FUNCTION _module = ((ModuleFunction) object).getModule();
            String _literal = _module.getLiteral();
            int _length = _literal.length();
            int pos = (_length + 1);
            ModuleName _name = ((ModuleFunction)object).getName();
            String _name_1 = _name.getName();
            int _length_1 = _name_1.length();
            acceptor.addPosition((offset + pos), _length_1, AlgorithmicHighlightingConfiguration.MODULE_NAME_ID);
            global = false;
          }
        }
        if (!_matched) {
          if (object instanceof ModuleProcedure) {
            _matched=true;
            MODULES_PROCEDURE _module = ((ModuleProcedure) object).getModule();
            String _literal = _module.getLiteral();
            int _length = _literal.length();
            int pos = (_length + 1);
            ModuleName _name = ((ModuleProcedure)object).getName();
            String _name_1 = _name.getName();
            int _length_1 = _name_1.length();
            acceptor.addPosition((offset + pos), _length_1, AlgorithmicHighlightingConfiguration.MODULE_NAME_ID);
            global = false;
          }
        }
        if (!_matched) {
          if (object instanceof ModuleRef) {
            _matched=true;
            ModuleName _ref = ((ModuleRef)object).getRef();
            String _name = _ref.getName();
            int _length = _name.length();
            acceptor.addPosition(offset, _length, AlgorithmicHighlightingConfiguration.MODULE_NAME_ID);
          }
        }
        if (!_matched) {
          if (object instanceof VarRef) {
            _matched=true;
            VarName _ref = ((VarRef)object).getRef();
            EObject _eContainer = _ref.eContainer();
            EObject _eContainer_1 = _eContainer.eContainer();
            EObject _eContainer_2 = _eContainer_1.eContainer();
            EObject _eContainer_3 = _eContainer_2.eContainer();
            if ((_eContainer_3 instanceof Algorithmic)) {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_GLOB_ID);
            } else {
              acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_LOC_ID);
            }
          }
        }
        if (!_matched) {
          if (object instanceof DataRef) {
            _matched=true;
            DataName _ref = ((DataRef)object).getRef();
            if ((_ref instanceof ConstName)) {
              DataName _ref_1 = ((DataRef)object).getRef();
              EObject _eContainer = _ref_1.eContainer();
              EObject _eContainer_1 = _eContainer.eContainer();
              EObject _eContainer_2 = _eContainer_1.eContainer();
              EObject _eContainer_3 = _eContainer_2.eContainer();
              if ((_eContainer_3 instanceof Algorithmic)) {
                acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.CONST_GLOB_ID);
              } else {
                acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.CONST_LOC_ID);
              }
            } else {
              DataName _ref_2 = ((DataRef)object).getRef();
              EObject _eContainer_4 = _ref_2.eContainer();
              EObject _eContainer_5 = _eContainer_4.eContainer();
              EObject _eContainer_6 = _eContainer_5.eContainer();
              EObject _eContainer_7 = _eContainer_6.eContainer();
              if ((_eContainer_7 instanceof Algorithmic)) {
                acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_GLOB_ID);
              } else {
                acceptor.addPosition(offset, length, AlgorithmicHighlightingConfiguration.VAR_LOC_ID);
              }
            }
          }
        }
        if (!_matched) {
          if (object instanceof LibraryName) {
            _matched=true;
            LibraryModule _name = ((LibraryName)object).getName();
            String _literal = _name.getLiteral();
            int _length = _literal.length();
            acceptor.addPosition(offset, _length, AlgorithmicHighlightingConfiguration.LIBRARY_NAME_ID);
          }
        }
      }
    }
  }
}
