package com.infoly.eclipse.xtext.algo.ui.wizards;

import com.google.common.collect.Iterables;
import java.util.Collections;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.ui.IEditorRegistry;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.WizardNewProjectCreationPage;
import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard;
import org.eclipse.xtext.ui.XtextProjectHelper;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class NewProject extends BasicNewProjectResourceWizard {
  private final String WINDOW_TITLE = "Algorithmic New Project";
  
  private final String PAGE_TITLE = "Nouveau Projet";
  
  private final String PAGE_DESCRIPTION = "Entrez les informations sur le projet.";
  
  private final String DEFAULT_PROJECT_NAME = "ProjetAlgorithmic";
  
  private final String DEFAULT_FILE_EXT = "alg";
  
  private final String ALGORITHMIC_EDITOR_ID = "com.infoly.eclipse.xtext.algo.Algorithmic";
  
  private final String ALGORITHMIC_PERSPECTIVE_ID = "com.infoly.eclipse.xtext.algo.ui.perspectives.algorithmic";
  
  /**
   * new() { // TODO Auto-generated constructor stub
   * }
   */
  @Override
  public void addPages() {
    super.addPages();
    this.setWindowTitle(this.WINDOW_TITLE);
    IWizardPage[] _pages = this.getPages();
    IWizardPage _get = _pages[0];
    final WizardNewProjectCreationPage page0 = ((WizardNewProjectCreationPage) _get);
    page0.setTitle(this.PAGE_TITLE);
    page0.setDescription(this.PAGE_DESCRIPTION);
    page0.setInitialProjectName(this.DEFAULT_PROJECT_NAME);
  }
  
  @Override
  public boolean performFinish() {
    try {
      super.performFinish();
      IProject _newProject = this.getNewProject();
      IProjectDescription _description = _newProject.getDescription();
      IProject _newProject_1 = this.getNewProject();
      IProjectDescription _description_1 = _newProject_1.getDescription();
      String[] _natureIds = _description_1.getNatureIds();
      Iterable<String> _plus = Iterables.<String>concat(((Iterable<? extends String>)Conversions.doWrapArray(_natureIds)), Collections.<String>unmodifiableList(CollectionLiterals.<String>newArrayList(XtextProjectHelper.NATURE_ID)));
      _description.setNatureIds(((String[])Conversions.unwrapArray(_plus, String.class)));
      IWorkbench _workbench = PlatformUI.getWorkbench();
      IEditorRegistry _editorRegistry = _workbench.getEditorRegistry();
      _editorRegistry.setDefaultEditor(this.DEFAULT_FILE_EXT, this.ALGORITHMIC_EDITOR_ID);
      IWorkbench _workbench_1 = this.getWorkbench();
      final IWorkbenchWindow window = _workbench_1.getActiveWorkbenchWindow();
      IWorkbench _workbench_2 = this.getWorkbench();
      _workbench_2.showPerspective(this.ALGORITHMIC_PERSPECTIVE_ID, window);
      return true;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
